#!/usr/bin/env python

# -------------------------------------------------------------------------------------
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY 
# EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT 
# SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
# TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR 
# BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN 
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH 
# DAMAGE.
#
# -------------------------------------------------------------------------------------

from gimpfu import *


############################################################################
# include, then use: erro_msg or info_msg
#---------------------------------------------------------------------------
def erro_msg (msg):
    ###
    currenth = pdb.gimp_message_get_handler()
    pdb.gimp_message_set_handler(0) # box
    gimp.message ("ERROR: "+msg)
    pdb.gimp_message_set_handler(currenth) # current
    ###
def info_msg (msg):
    ###
    currenth = pdb.gimp_message_get_handler()
    pdb.gimp_message_set_handler(2) # error console
    gimp.message ("INFO: "+msg)
    pdb.gimp_message_set_handler(currenth) # current
    ###
############################################################################
#

def ChildishPaint (img, layer, howmany) :

################# MrQ add option: create as new image #########################
    active_layer = pdb.gimp_image_get_active_layer(img)
    w = pdb.gimp_drawable_width(active_layer)
    h = pdb.gimp_drawable_height(active_layer)

    new_image = pdb.gimp_image_new(w, h, 0)

    display = pdb.gimp_display_new(new_image)

    active_layer = pdb.gimp_layer_new_from_drawable(layer, new_image)
    pdb.gimp_image_insert_layer(new_image, active_layer, None, 0)	
    active_layer.name = layer.name
    layer = active_layer
    pdb.gimp_displays_flush()
    #pdb.gimp_image_convert_precision(new_image, 150)	# PRECISION_U8_GAMMA
###############################################################################
    # Get the layer position.
    pos = 0;
    for i in range(len(img.layers)):
        if(img.layers[i] == layer):
            pos = i
    
    # Create a new layer to save the results (otherwise is not possible to undo the operation).
    newLayer = pdb.gimp_layer_new_from_drawable(active_layer, new_image)
    pdb.gimp_image_insert_layer(new_image, newLayer, None, 0)	
    newLayer.name = active_layer.name + " mod"  
    # simplify
    pdb.plug_in_sel_gauss (new_image, newLayer, 15.0, 64)
    
    # max saturation
    pdb.gimp_hue_saturation (newLayer, 0, 0, 0, +100)
    
    # change image mode to indexed  

    pdb.gimp_image_convert_indexed (new_image, 0, 0, howmany, 0, 0, "ignored")
    is_indexed=pdb.gimp_drawable_is_indexed (newLayer) 
    if is_indexed==1:
        hidden_message="OK, converted"
    else:    
        erro_msg ("Image not converted to indexed, exit")
        pdb.gimp_context_pop
        pdb.gimp_display_new (newImage)
        return    

    # re-set image to RGB to proceed
    # ==============================
    pdb.gimp_image_convert_rgb (new_image)
    
    # max saturation again
    finalLayer = pdb.gimp_image_merge_down (new_image, newLayer, CLIP_TO_BOTTOM_LAYER)
	
    sourcename = finalLayer.name
    if '.' in sourcename:
        split = sourcename.split(".", 1)
        sourcename = split[0]
    finalLayer.name = sourcename + " childish paint"



register(
    "ChildishPaint",    "Childish Paint\nCreates a new image from the active layer.",    "ChildishPaint.",
    "Dinasset",    "Open source (BSD 3-clause license)",    "2017",
    "Childish Paint...",
    "RGB, RGB*",
    [
      (PF_IMAGE, "image", "Input image", None),
      (PF_DRAWABLE, "drawable", "Input drawable", None),
      (PF_ADJUSTMENT, "colours", "How many colours",  11, (4, 255, 1)), 		#default, (min, max, increment)
    ],
    [
      (PF_DRAWABLE, "outdrawable", "Output drawable", None),
    ],
    ChildishPaint,
    menu="<Image>/Diego/Ancillary"
    )

main()
